;Visor de pantallas simples modo 256x192
;Para generar una pantalla compatible con este modo:
; - Convertir una imagen RGB a 256x192, 16 colores paletizados
; - Grabarla como BMP sin compresin
; - Integrarla como archivo binario a este programa


;Codigo objeto total ocupa 24792 bytes

               org 40743

;Pantalla en modo 9 acaba en direccion:
;16384+24576=40960
;Por tanto llegara a sobreescribir estas primeras direcciones,
;primero este codigo de aqui y luego la cabecera del bmp
;por ultima instancia, llega a escribir justo antes de la primera direccion de pixeles del bmp
;(40868) mientras va a escribir la ultima linea de pantalla (40832).
;dado que 40832 < 40868 hay un ligero margen para que la operacion ldir funcione y toda la pantalla se vea bien


Main
		;saltamos a rutina del bmp para que no nos "pille" sobreescribiendo esta zona
		di
		ld sp,mipila
		jp Main2

;Dado que el bmp en memoria y la pantalla ocupan mas de los 48kb, la pantalla llegara a sobreescribir esta zona
;(16384+24576=40960)
;Por tanto leeremos menos lineas (182 en vez de 192)

BMPFile		equ $
               incbin "dragonballgt.bmp"  ; <-- pon aqui el fichero BMP que quieras ver. Debe tener 24694 bytes de longitud

;Espacio para stack. Como solo se hace un push, con 2 bytes es suficiente
		defs 2
mipila 		equ $


               ;Convertir la paleta del BMP a paleta de ULAplus
Main2          ld hl,BMPFile+36h  ;offset de la paleta en los BMP. El formato de la paleta es BGRA
               ld bc,0bf3bh
               ld e,0
BucPaleta      out (c),e
               ld b,0ffh
               ld a,(hl)   ; azul
               sra a
               sra a
               sra a
               sra a
               sra a
               sra a
               and 3
               ld d,a
               inc hl
               ld a,(hl)   ; verde
               and 11100000b
               or d
               ld d,a
               inc hl
               ld a,(hl)   ; rojo
               sra a
               sra a
               sra a
               and 00011100b
               or d
               out (c),a
               inc hl
               inc hl      ; nos saltamos el byte de "alpha"
               ld b,0bfh
               inc e
               ld a,e
               cp 16
               jr nz,BucPaleta

               ld a,64
               out (c),a
               ld b,0ffh
               ld a,9
               out (c),a

               ld hl,BMPFile+76h+191*128   ;offset a la ltima lnea del BMP (la primera en pantalla)
               ld de,16384                ;offset al comienzo de pantalla
               ld b,192
BucPintaScans  push bc
               ld bc,128
               ldir
               ld bc,-256
               add hl,bc
               pop bc
               djnz BucPintaScans

buclesinsalida jr buclesinsalida

               end Main
